/*###############################################################################
# Linux Management Providers (LMP), Boot provider package
# Copyright (C) 2009 Nodir Nazarov <nazarov.nodir@gmail.com>
#
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
#
# Modified by 2009 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr>
###############################################################################*/

#ifndef CMPIOPENDRIM_BOOTCONFIGSETTING_H_
#define CMPIOPENDRIM_BOOTCONFIGSETTING_H_

#include "OpenDRIM_BootConfigSetting.h"

CMPIObjectPath* Boot_OpenDRIM_BootConfigSetting_toCMPIObjectPath(const CMPIBroker* broker, const OpenDRIM_BootConfigSetting& instance);

CMPIInstance* Boot_OpenDRIM_BootConfigSetting_toCMPIInstance(const CMPIBroker* broker, const OpenDRIM_BootConfigSetting& instance);

void Boot_OpenDRIM_BootConfigSetting_toCPP(const CMPIBroker* broker, const CMPIObjectPath* ref, OpenDRIM_BootConfigSetting& instance);

void Boot_OpenDRIM_BootConfigSetting_toCPP(const CMPIBroker* broker, const CMPIInstance* ci, OpenDRIM_BootConfigSetting& instance);

void Boot_OpenDRIM_BootConfigSetting_toCPP(const CMPIBroker* broker, const CMPIArgs* in, OpenDRIM_BootConfigSetting_ChangeBootOrder_In& args);

void Boot_OpenDRIM_BootConfigSetting_toCMPIArg(const CMPIBroker* broker, CMPIArgs* out, const OpenDRIM_BootConfigSetting_ChangeBootOrder_Out& args);


#endif /*CMPIOPENDRIM_BOOTCONFIGSETTING_H_*/
