/*###############################################################################
# Linux Management Providers (LMP), Boot provider package
# Copyright (C) 2009 Nodir Nazarov <nazarov.nodir@gmail.com>
#
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
#
# Modified by 2009 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr>
###############################################################################*/

#ifndef OPENDRIM_BOOTHOSTEDSERVICEACCESS_H_
#define OPENDRIM_BOOTHOSTEDSERVICEACCESS_H_

#include "Boot_Common.h"

#include "OpenDRIM_BootHostedService.h"
#include "assocOpenDRIM_BootHostedService.h"

int Boot_OpenDRIM_BootHostedService_load(const CMPIBroker* broker, string& errorMessage);

int Boot_OpenDRIM_BootHostedService_unload(string& errorMessage);

int Boot_OpenDRIM_BootHostedService_retrieve(const CMPIBroker* broker, const CMPIContext* ctx, vector<OpenDRIM_BootHostedService>& instances, const char** properties, string& errorMessage, const string& discriminant);

int Boot_OpenDRIM_BootHostedService_getInstance(const CMPIBroker* broker, const CMPIContext* ctx, OpenDRIM_BootHostedService& instance, const char** properties, string& errorMessage);

int Boot_OpenDRIM_BootHostedService_setInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_BootHostedService& newInstance, const OpenDRIM_BootHostedService& oldInstance, const char** properties, string& errorMessage);

int Boot_OpenDRIM_BootHostedService_createInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_BootHostedService& instance, string& errorMessage);

int Boot_OpenDRIM_BootHostedService_deleteInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_BootHostedService& instance, string& errorMessage);

int Boot_OpenDRIM_BootHostedService_associatorAntecedentToDependent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Antecedent_instance, const char** properties, vector<Instance>& Dependent_associatedInstances, string& errorMessage, const string& discriminant);

int Boot_OpenDRIM_BootHostedService_associatorDependentToAntecedent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Dependent_instance, const char** properties, vector<Instance>& Antecedent_associatedInstances, string& errorMessage, const string& discriminant);

int Boot_OpenDRIM_BootHostedService_referenceAntecedentToDependent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Antecedent_instance, const vector<Instance>& Dependent_instances, vector<OpenDRIM_BootHostedService>& OpenDRIM_BootHostedService_instances, const char** properties, string& errorMessage, const string& discriminant);

int Boot_OpenDRIM_BootHostedService_referenceDependentToAntecedent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Dependent_instance, const vector<Instance>& Antecedent_instances, vector<OpenDRIM_BootHostedService>& OpenDRIM_BootHostedService_instances, const char** properties, string& errorMessage, const string& discriminant);

int Boot_OpenDRIM_BootHostedService_populate(OpenDRIM_BootHostedService& instance, string& errorMessage);

#endif /*OPENDRIM_BOOTHOSTEDSERVICEACCESS_H_*/
